#include <math.h>
#include "pepravka.h"
#include <numbers>
#include <iostream>

using namespace std;

const double pi = 3.14159265358979353;

auto sqr(double x)
{
	return x * x;
}

Pepravka::Pepravka()
{
	x = 1;
	y = 0;
	z = 0;
	poet = 0;
}

void Pepravka::pijmi(double gama1, double gama2)
{
	auto costheta = 2 * gama1 - 1;
	auto sintheta = sqrt(1 - sqr(costheta));
	auto fi = 2 * pi * gama1;
	x = sintheta * sin(fi);
	y = sintheta * cos(fi);
	z = costheta;
	poet++;
}

string Pepravka::data()
{
	kontrola();
	return "("s + to_string(x) + ", "s + to_string(y) + ", "s + to_string(z) + ")"s;
}

void Pepravka::kontrola()
{
	auto eps = sqr(x) + sqr(y) + sqr(z) - 1.0;
	if (eps > 1e-12)
	{
		cout << "Konme pro nekonzistenci dat po " << poet << " dodvkch, eps je " << eps << endl;
		abort();
	}
}

Pepravka pepravka;